Debian Bug report logs - #685750
IA64 (Itanium) Wheezy, mach64, decommissioned xorg drivers

version graph

Package: xserver-xorg-core; Maintainer for xserver-xorg-core is Debian X Strike Force <debian-x@lists.debian.org>; Source for xserver-xorg-core is src:xorg-server.

Reported by: Stephan Schreiber <info@fs-driver.org>

Date: Fri, 24 Aug 2012 11:00:02 UTC

Severity: grave

Tags: patch

Fixed in version xorg-server/2:1.12.4-2

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#685750; Package xserver-xorg-video-mach64. (Fri, 24 Aug 2012 11:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephan Schreiber <info@fs-driver.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 24 Aug 2012 11:00:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stephan Schreiber <info@fs-driver.org>
To: submit@bugs.debian.org
Subject: IA64 (Itanium) Wheezy, mach64, decommissioned xorg drivers
Date: Fri, 24 Aug 2012 12:56:00 +0200
Package: xserver-xorg-video-mach64
Severity: important
Tags: wheezy



IA64 (Itanium) Wheezy, mach64, decommissioned xorg drivers


Boot method: netinst CD
Image version: a self build netinst CD which bases on the data of
Wheezy beta-1 and the patch proposals of bug#678883, 679545, 685186.
Date: Aug. 24, 2012

Machine: Dell PowerEdge 3250
Processor: 2x Itanium Madison 1.5GHz 6M
Memory: 4G
Graphics: build-in ATI Rage XL
01:01.0 VGA compatible controller [0300]: Advanced Micro Devices [AMD]
nee ATI Rage XL [1002:4752] (rev 27)
	Subsystem: Intel Corporation Device [8086:3404]


I could install a minimum Debian Wheezy with my self-build netinst CD.  
I installed gnome-core but after the next reboot the screen flashed a  
few times, was completely black a few seconds later, the hard disk  
drive led flashed rythmic. Switching to another console wasn't possible.


There was a large count of xorg log files:
/var/log/Xorg.0.log
/var/log/Xorg.0.log.old
/var/log/Xorg.1.log
/var/log/Xorg.1.log.old
....
/var/log/Xorg.200.log
/var/log/Xorg.200.log.old
....

what gives me an idea what happened while the hard disk drive led  
flashed rythmic.
Graphics is a ATI Rage XL, the 'mach64' xorg driver would be the right  
one - 'mach64' might be loaded by the 'ati' xorg driver.
The most interesting lines in Xorg.0.log.old are
[    92.560] (II) LoadModule: "ati"
[    92.560] (II) Loading /usr/lib/xorg/modules/drivers/ati_drv.so
[    92.560] (II) Module ati: vendor="X.Org Foundation"
[    92.560] 	compiled for 1.12.1.902, module version = 6.14.4
[    92.580] 	Module class: X.Org Video Driver
[    92.580] 	ABI class: X.Org Video Driver, version 12.0
[    92.581] (II) LoadModule: "mach64"
[    92.581] (WW) Warning, couldn't open module mach64
[    92.581] (II) UnloadModule: "mach64"
[    92.581] (II) Unloading mach64
[    92.581] (EE) Failed to load module "mach64" (module does not exist, 0)

Then I found the Debian bug#671386 report. I thought my glasses lift  
up when I read it :-).


This is the commit which removed the functions inb, inw, inl, outb,  
outw, outl:
http://cgit.freedesktop.org/xorg/xserver/commit/?id=aa0bfb0f133481c57762012e8e30c05ffa151423

The commit reads at the top
"pciaccess handles this now."

A removed comment reads
- * We use special in/out routines here since Altix platforms require the
- * use of the sysfs legacy_io interface.  The legacy_io file maps to the I/O
- * space of a given PCI domain; reads and writes are used to do port I/O.
- * The file descriptor for the file is stored in the upper bits of the
- * value passed in by the caller, and is created and populated by
- * xf86MapLegacyIO.
- *
- * If the legacy_io interface doesn't exist, we fall back to the glibc in/out
- * routines, which are prefixed by an underscore (e.g. _outb).


Further investigations are needed...

Kind regards
Stephan Schreiber






Removed tag(s) wheezy. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Fri, 24 Aug 2012 15:15:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#685750; Package xserver-xorg-video-mach64. (Wed, 29 Aug 2012 09:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephan Schreiber <info@fs-driver.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 29 Aug 2012 09:42:03 GMT) Full text and rfc822 format available.

Message #12 received at 685750@bugs.debian.org (full text, mbox):

From: Stephan Schreiber <info@fs-driver.org>
To: 685750@bugs.debian.org
Subject: IA64 (Itanium) Wheezy, mach64, decommissioned xorg drivers, patch proposal
Date: Wed, 29 Aug 2012 11:37:36 +0200
[Message part 1 (text/plain, inline)]
Earlier, in xorg-server-core 1.11.4, the ia64 architecture had an  
extra module hw/xfree86/os-support/shared/ia64Pci.c
which implemented inb, inw, inl, outb, outw, outl:

static int ia64_port_to_fd(unsigned long port)
{
    return (port >> 24) & 0xffffffff;
}

void outb(unsigned long port, unsigned char val)
{
    int fd = ia64_port_to_fd(port);

    if (!fd) {
	_outb(val, port & 0xffff);
	goto out;
    }
    if (lseek(fd, port & 0xffff, SEEK_SET) == -1) {
	ErrorF("I/O lseek failed\n");
	goto out;
    }
    if (write(fd, &val, 1) != 1) {
	ErrorF("I/O write failed\n");
	goto out;
    }
 out:
    return;
}

....


The high part of the port is taken as file handle for a "legacy_io file".
If the high part is 0, the _inb, _inw, _inl, _outb, _outw, _outl  
functions of glibc are used.

The mentioned file handle is opened in xf86MapLegacyIO() in  
hw/xfree86/bus/linuxPci.c in xorg-server-core 1.11.4.

The xf86MapLegacyIO() does no longer attempt to open a "legacy_io  
file" in 1.12.3 (now hw/xfree86/common/xf86pciBus.c).

Thus, the mentioned hw/xfree86/os-support/shared/ia64Pci.c file with  
inb, inw, inl, outb, outw, outl has been removed with the mentioned  
patch
http://cgit.freedesktop.org/xorg/xserver/commit/?id=aa0bfb0f133481c57762012e8e30c05ffa151423

This is correct so far.

It has been noticed that the xorg-server-core declares inb, inw, inl,  
outb, outw, outl in its compiler.h but doesn't implement these  
functions.
The result was the patch
http://cgit.freedesktop.org/xorg/xserver/commit/?id=644efb43e0639af648dd46d9729c2cabd9511238
which removed the declarations of inb, inw, inl, outb, outw, outl in ia64.

Some drivers need the inb, inw, inl, outb, outw, outl functions; you  
could read in bug#671386 what drivers these are.
These driver package couldn't be build on ia64 from now and have been  
removed from Debian Wheezy (ugh).

The fix is simple: we need inb, inw, inl, outb, outw, outl on ia64  
which are wrappers of the glibc functions _inb, _inw, _inl, _outb,  
_outw, _outl.
This is equivalent to the 'glicbc' fallback of the removed ia64Pci.c.

The patch defines inb, inw, inl, outb, outw, outl as inline functions  
in the compiler.h - similar as it is already done for alpha.

I build the xorg-server-core 1.12.3 with this patch - and the ones of  
bug#686152 and 686153.
After installation of the built
xserver-xorg-dev_1.12.3-1_ia64.deb
I was able to build and install the xserver-xorg-video-mach64 (6.9.1)  
package - without any modification.
After a startx, x started and worked.
I bet, the other affected video drivers could be built after that as well.

Please could you apply the proposed patch and revert bug#671386? This  
would be great.


Best regards
Stephan Schreiber


[fix_inx_outx.patch (application/octet-stream, attachment)]

Added tag(s) patch. Request was from info@fs-driver.org to control@bugs.debian.org. (Thu, 06 Sep 2012 16:45:06 GMT) Full text and rfc822 format available.

Severity set to 'grave' from 'important' Request was from Stephan Schreiber <info@fs-driver.org> to control@bugs.debian.org. (Sat, 08 Sep 2012 06:54:02 GMT) Full text and rfc822 format available.

Bug reassigned from package 'xserver-xorg-video-mach64' to 'xserver-xorg-core'. Request was from Stephan Schreiber <info@fs-driver.org> to control@bugs.debian.org. (Sat, 08 Sep 2012 06:54:03 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Sun, 04 Nov 2012 00:21:27 GMT) Full text and rfc822 format available.

Notification sent to Stephan Schreiber <info@fs-driver.org>:
Bug acknowledged by developer. (Sun, 04 Nov 2012 00:21:27 GMT) Full text and rfc822 format available.

Message #23 received at 685750-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 685750-close@bugs.debian.org
Subject: Bug#685750: fixed in xorg-server 2:1.12.4-2
Date: Sun, 04 Nov 2012 00:19:37 +0000
Source: xorg-server
Source-Version: 2:1.12.4-2

We believe that the bug you reported is fixed in the latest version of
xorg-server, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 685750@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xorg-server package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Wed, 24 Oct 2012 16:46:48 +0200
Source: xorg-server
Binary: xserver-xorg-core xserver-xorg-core-udeb xserver-xorg-dev xdmx xdmx-tools xnest xvfb xserver-xephyr xserver-xfbdev xserver-xorg-core-dbg xserver-common
Architecture: source all amd64
Version: 2:1.12.4-2
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xdmx       - distributed multihead X server
 xdmx-tools - Distributed Multihead X tools
 xnest      - Nested X server
 xserver-common - common files used by various X servers
 xserver-xephyr - nested X server
 xserver-xfbdev - Linux framebuffer device tiny X server
 xserver-xorg-core - Xorg X server - core server
 xserver-xorg-core-dbg - Xorg - the X.Org X server (debugging symbols)
 xserver-xorg-core-udeb - Xorg X server - core server (udeb)
 xserver-xorg-dev - Xorg X server - development files
 xvfb       - Virtual Framebuffer 'fake' X server
Closes: 666468 685750 689246
Changes: 
 xorg-server (2:1.12.4-2) unstable; urgency=low
 .
   * Fix Xephyr command line option parsing (closes: #689246).  Thanks, Andrzej
     Pietrasiewicz!
   * Restore {in,out}{b,w,l} on ia64 (closes: #685750).  Thanks, Stephan
     Schreiber!
   * EXA: Fall back earlier and more thoroughly from exaGlyphs (closes:
     #666468).  Patch by Michel Dänzer stolen from upstream bugzilla.
Checksums-Sha1: 
 39bdb9f7b96fcec22b56797ba80ceb90fbe841aa 4095 xorg-server_1.12.4-2.dsc
 b98dfec1add259d9606cc415e5c21803def0813e 88877 xorg-server_1.12.4-2.diff.gz
 35cc27ec6236b86712c9bf136119054b7f531ec4 1395468 xserver-common_1.12.4-2_all.deb
 2ae7c8682e970ed6b3815e420467767f34226dcb 1761186 xserver-xorg-core_1.12.4-2_amd64.deb
 2096b8894566bfaeb99e9163e0fa0572fd8a7d0d 867068 xserver-xorg-core-udeb_1.12.4-2_amd64.udeb
 f8dfad09b85e2c408a3c906c8879e8fd3f3ce15f 319568 xserver-xorg-dev_1.12.4-2_amd64.deb
 4f367ca1928987998e8c088dc1816932bc8346aa 922404 xdmx_1.12.4-2_amd64.deb
 deaf92e2b076464ad3e2460d47bc62d0888fb35b 125010 xdmx-tools_1.12.4-2_amd64.deb
 a313d86029116e677aae23adc39868ab75ac30c4 820934 xnest_1.12.4-2_amd64.deb
 3380e13068322600dcf7dc89dee57795d2662abf 924594 xvfb_1.12.4-2_amd64.deb
 4eb1d140eecefe9f40c7a5a9c6c4fe15e757d25b 1017286 xserver-xephyr_1.12.4-2_amd64.deb
 7f2f126b1f5e2bd80e2cdd9f1c6cac85b275e1d1 939272 xserver-xfbdev_1.12.4-2_amd64.deb
 80eb0afe225d17147b16ada30a46d0d2a027fbf9 7290316 xserver-xorg-core-dbg_1.12.4-2_amd64.deb
Checksums-Sha256: 
 8c523adec82f279efd93ae1d8183e24a396f21a1ea5d4d613f119202dc15d39e 4095 xorg-server_1.12.4-2.dsc
 9dea49f2be35e56582b122df67b4560c9bc5268997f12b20183a5fa4b78f44fd 88877 xorg-server_1.12.4-2.diff.gz
 4baf42b8ad55b39d284b2071e690daeef4df1d18c97c4acf34534eefc8fc4d0d 1395468 xserver-common_1.12.4-2_all.deb
 e04af655a0457fa5a1e08ced00a9a96775206ac1716e18961a06eebc0f717ee6 1761186 xserver-xorg-core_1.12.4-2_amd64.deb
 4b5ec1069c7563bcc87c887d2fbfe31f0e5473a1a8b3a35eb8f0971cabe4da3a 867068 xserver-xorg-core-udeb_1.12.4-2_amd64.udeb
 8b722c02fa4edf67f91f5d73a6984b5e345fc1de09c996f3d3949c593bf3b084 319568 xserver-xorg-dev_1.12.4-2_amd64.deb
 7855070b7ce68bea5b1046c6c4163e0491773f82aab846641a8e9eff7fca6b4d 922404 xdmx_1.12.4-2_amd64.deb
 bc2e4e389150fc9f137c8cc5f6110bc1cd3973d0e3a4705e4f483f6bb42013fb 125010 xdmx-tools_1.12.4-2_amd64.deb
 85c3590e8118b92d520fee9c8ba8372a0fccd6c62cc75e1e5267239f3aaac9ef 820934 xnest_1.12.4-2_amd64.deb
 73bf634dcb2a8a321fecd52e887b754b70fdcf20044498795bbeec5804985a3e 924594 xvfb_1.12.4-2_amd64.deb
 d086e987e9d2a85b922764d351a87aa3eaacc1c8f90d03bb8c9f96af34d1ba0f 1017286 xserver-xephyr_1.12.4-2_amd64.deb
 728c9e6b7ba48347a48863d0f49459276d2a04a64858927690cd4de7de7f39b3 939272 xserver-xfbdev_1.12.4-2_amd64.deb
 4f1beafe6b078e00554a2d7c071d34dd1cf9b1bbab8ca84886e8dc2a7e07915a 7290316 xserver-xorg-core-dbg_1.12.4-2_amd64.deb
Files: 
 75134342871290680a86a886dee76e92 4095 x11 optional xorg-server_1.12.4-2.dsc
 b0a18f26581f50c467724c4ad3d8d7c0 88877 x11 optional xorg-server_1.12.4-2.diff.gz
 898fddab13814ea72342e5fe37a3e62a 1395468 x11 optional xserver-common_1.12.4-2_all.deb
 7f0eb7c3aea1cee607d27a0cdc80e724 1761186 x11 optional xserver-xorg-core_1.12.4-2_amd64.deb
 8cc9ce75923e09959f5cda8e67efcdbc 867068 debian-installer optional xserver-xorg-core-udeb_1.12.4-2_amd64.udeb
 4f63d2c648a710de814a67003d55fcc7 319568 x11 optional xserver-xorg-dev_1.12.4-2_amd64.deb
 dabc0638bcd7f8a1438674fb96672314 922404 x11 optional xdmx_1.12.4-2_amd64.deb
 07890b378e0b0fab9a58f1ba1f982417 125010 x11 optional xdmx-tools_1.12.4-2_amd64.deb
 f5bae05e8c31e951ee96e5d23ed39a72 820934 x11 optional xnest_1.12.4-2_amd64.deb
 2a5f875af244c58d974e47219121f6e5 924594 x11 optional xvfb_1.12.4-2_amd64.deb
 7aeb358c5292035ebfa0a9c3802370f4 1017286 x11 optional xserver-xephyr_1.12.4-2_amd64.deb
 a0476622a3976dd1fef26e02b4ee7fe1 939272 x11 optional xserver-xfbdev_1.12.4-2_amd64.deb
 38edc4da7ad2acf22465c746ce20078b 7290316 debug extra xserver-xorg-core-dbg_1.12.4-2_amd64.deb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJQlaxSAAoJEDEBgAUJBeQMVJYP/2VOSgIiPtfQEJHhhQTywlY+
eVPFV3IdkpPsGH9ea+ACDSXqumHfPQUPF81DIjm7QNKtkBKqZ7mskXqwxBVALLRB
5eV0PPghz95LMBNYsJGMGh5l0LTpAi+En9zLfmXEqHbTH14M2cFTCbiNf2oCDkyv
AsvEuLjMlRhBqo0s8+CVuOLqPU8tM0tAiE6GjFGri+Kh2XnFy5E+PjYHklo0l5fl
J4ho5vM1xs2k8vmpy4fi+TjPCXUTBttfiziLU/Zw5rFE0z+JYxJ3oWzCQKpGmH/H
/IZoBat6nq5KJrHtr/badcKV6NXO0557ZmdJRzjupD1myXI+rW57gYeZgKmrItMk
TIBOUEE71aJNIV3uxJg98qs9JhqZ/w7meIdaNiQ0YMKnj+JUrhFoWExUMvkjyn7Z
hC/4vrKVmijTYCJX1Fq/WAwWksEZo7y3gpWkdEgrFv8RuN4BrJAyswG6+WCsGN/q
CXz6v3U1jdVJp0PtiYcMs+PaBdn9e8VRITGbOtKZY6DGtWxasJkLgCc02SnNPctf
3wP+bJWH8OueSHqeEXX4TYMvsOr6iKvR1fShH+bXG7rFUxHv85SXwG6nn3W1vZbi
lVLoaysZt9rL7iwpE6FpoBuxqTHV9/1V1gY2KEf+ROyq/PB4jfFxarG1IH1a49vD
7fOyuftNryGHtUyC7Ed7
=yt+4
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 03 Dec 2012 07:27:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 23:18:46 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.